Imports System.Data.SqlClient
Imports Logic.NullableDateExtensions
Imports Logic.DateExtensions
Imports ReportingClass

Public Class TrafficViolations
    Inherits System.Web.UI.Page

    Private Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Try

            If Not Page.IsPostBack Then
                If Not _HasVisited() Then
                    _Prefill()
                End If
                _LoadForm()
                _LoadLists()
            Else
                _SaveAll()
                Page.Validate()
                If Page.IsValid Then
                    Master.EnableNextPage()
                End If
            End If

        Catch ex As Exception
            Dim errorId = Logic.Error.Log(ex)
            Response.Redirect("/Error.aspx?id=" & errorId)
        End Try
    End Sub

    Private Sub btnAddViolation_Click(sender As Object, e As EventArgs) Handles rptViolations.AddClick
        Try
            If _HasEnteredLastViolation() Then
                rptViolations.TargetCount = Math.Max(rptViolations.TargetCount, rptViolations.Items.Count) + 1
            End If
            _LoadViolationList()
        Catch ex As Exception
            Dim errorId = Logic.Error.Log(ex)
            Response.Redirect("/Error.aspx?id=" & errorId)
        End Try
    End Sub

    Protected Sub btnRemoveViolation_Click(sender As Object, e As EventArgs)
        Try

            rptViolations.TargetCount = Math.Max(rptViolations.TargetCount, rptViolations.Items.Count) - 1

            Dim btnRemove = DirectCast(sender, Button)
            Dim item = DirectCast(btnRemove.Parent, RepeaterItem)
            Dim hidId = DirectCast(item.FindControl("hidViolationId"), HiddenField)

            _RemoveViolation(CInt(hidId.Value))
            _LoadViolationList()

        Catch ex As Exception
            Dim errorId = Logic.Error.Log(ex)
            Response.Redirect("/Error.aspx?id=" & errorId)
        End Try
    End Sub

#Region "Loading internals"

    Private Sub _LoadForm()
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()

            Dim cmd As New SqlCommand("
                SELECT hasHadConvictions
                FROM web_DriverApplication WHERE id=@appId",
                connection)
            cmd.Parameters.AddWithValue("appId", Master.app.id)
            Dim dReader = cmd.ExecuteReader()
            dReader.Read()

            'ynLicenseDenied.Checked = Logic.Conversion.ToNullableBoolean(dReader("hasBeenDeniedLicense"))
            'ynLicenseRevoked.Checked = Logic.Conversion.ToNullableBoolean(dReader("hasHadLicenseRevoked"))
            'ynThreeYearsAccidents.Checked = Logic.Conversion.ToNullableBoolean(dReader("hasHadAccidents"))
            ynViolations.Checked = Logic.Conversion.ToNullableBoolean(dReader("hasHadConvictions"))
            'txtLicenseDeniedExplanation.Text = Logic.Conversion.ToString(dReader("licenseDeniedExplanation"))
            'txtLicenseRevokedExplanation.Text = Logic.Conversion.ToString(dReader("licenseRevokedExplanation"))

        End Using
    End Sub

    Private Sub _LoadLists()

        _LoadViolationList()
    End Sub



    Private Sub _LoadViolationList()
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()

            Dim cmdCount As New SqlCommand(
                "SELECT COUNT(id) FROM web_DriverApplicationConvictions WHERE AppId=@appId",
                connection)
            cmdCount.Parameters.AddWithValue("appId", Master.app.id)
            Dim count = CInt(cmdCount.ExecuteScalar())
            count = Math.Max(count, rptViolations.TargetCount)

            Dim cmdViolations As New SqlCommand("
                SELECT * FROM web_DriverApplicationConvictions
                WHERE AppId=@appId",
                connection)
            cmdViolations.Parameters.AddWithValue("appId", Master.app.id)

            Dim dummy As New List(Of Integer)
            For i = 1 To count : dummy.Add(i) : Next
            rptViolations.DataSource = dummy
            rptViolations.DataBind()

            ' We lose list of states after repeater rebind.
            ' This refills the states so that we can set them back.
            For Each item As RepeaterItem In rptViolations.Items
                Dim ddlConvictionState As StatePicker = item.FindControl("ddlConvictionState")
                ddlConvictionState.Rebind()
            Next

            Dim dReader = cmdViolations.ExecuteReader()
            For Each item As RepeaterItem In rptViolations.Items
                Dim hidId As HiddenField = item.FindControl("hidViolationId")
                Dim txtConvictionDate As TextBox = item.FindControl("txtConvictionDate")
                Dim ddlConvictionState As StatePicker = item.FindControl("ddlConvictionState")
                Dim txtConvictionCharge As TextBox = item.FindControl("txtConvictionCharge")
                Dim txtConvictionPenalty As TextBox = item.FindControl("txtConvictionPenalty")

                If dReader.Read() Then
                    hidId.Value = dReader("id")
                    txtConvictionDate.Text = Logic.Conversion.ToDate(dReader("Date")).FormatForHtml5()
                    ddlConvictionState.SelectedValue = dReader("State")
                    txtConvictionCharge.Text = dReader("Charge")
                    txtConvictionPenalty.Text = dReader("Penalty")
                End If
            Next

        End Using
    End Sub

    Private Sub _Prefill()
        '
    End Sub

#End Region

#Region "Saving internals"

    Private Sub _SaveAll()
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()
            Using transaction = connection.BeginTransaction()
                _SaveForm(connection, transaction)
                _SaveLists(connection, transaction)
                _SaveDocument(connection, transaction)
                transaction.Commit()
            End Using
        End Using
    End Sub

    Private Sub _SaveForm(connection As SqlConnection, transaction As SqlTransaction)

        'Dim licenseDenied = ynLicenseDenied.Checked
        'Dim licenseRevoked = ynLicenseRevoked.Checked
        'Dim hadAccidents = ynThreeYearsAccidents.Checked
        Dim hadConvictions = ynViolations.Checked

        Dim cmdSave As New SqlCommand("
            UPDATE web_DriverApplication
            SET hasHadConvictions=@hasHadConvictions
            WHERE id=@appId",
            connection, transaction)

        With cmdSave.Parameters
            .AddWithValue("appId", Master.app.id)
            '.AddWithValue("hasBeenDeniedLicense", If(licenseDenied.HasValue, licenseDenied.Value, DBNull.Value))
            '.AddWithValue("licenseDeniedExplanation", If(licenseDenied.HasValue, txtLicenseDeniedExplanation.Text, DBNull.Value))
            '.AddWithValue("hasHadLicenseRevoked", If(licenseRevoked.HasValue, licenseRevoked.Value, DBNull.Value))
            '.AddWithValue("licenseRevokedExplanation", If(licenseRevoked.HasValue, txtLicenseRevokedExplanation.Text, DBNull.Value))
            '.AddWithValue("hasHadAccidents", If(hadAccidents.HasValue, hadAccidents.Value, DBNull.Value))
            .AddWithValue("hasHadConvictions", If(hadConvictions.HasValue, hadConvictions.Value, DBNull.Value))
        End With

        cmdSave.ExecuteNonQuery()

    End Sub

    Private Sub _SaveLists(connection As SqlConnection, transaction As SqlTransaction)
        _SaveViolationList(connection, transaction)
    End Sub


    Private Sub _SaveViolationList(connection As SqlConnection, transaction As SqlTransaction)

        Dim cmdDelete As New SqlCommand(
            "DELETE FROM web_DriverApplicationConvictions WHERE AppId=@appId",
            connection, transaction)
        cmdDelete.Parameters.AddWithValue("appId", Master.app.id)
        cmdDelete.ExecuteNonQuery()

        Dim cmdSave As New SqlCommand("
            INSERT INTO web_DriverApplicationConvictions
            (AppId, [Date], [State], Charge, Penalty)
            VALUES (@appId, @date, @state, @charge, @penalty);
            SELECT @@IDENTITY;",
            connection, transaction)
        With cmdSave.Parameters
            .AddWithValue("appId", Master.app.id)
            .Add(New SqlParameter("date", SqlDbType.VarChar))
            .Add(New SqlParameter("state", SqlDbType.VarChar))
            .Add(New SqlParameter("charge", SqlDbType.VarChar))
            .Add(New SqlParameter("penalty", SqlDbType.VarChar))
        End With

        For Each item As RepeaterItem In rptViolations.Items
            Dim hidId As HiddenField = item.FindControl("hidViolationId")
            Dim txtConvictionDate As TextBox = item.FindControl("txtConvictionDate")
            Dim ddlConvictionState As StatePicker = item.FindControl("ddlConvictionState")
            Dim txtConvictionCharge As TextBox = item.FindControl("txtConvictionCharge")
            Dim txtConvictionPenalty As TextBox = item.FindControl("txtConvictionPenalty")

            cmdSave.Parameters("date").Value = Logic.Conversion.ToDate(txtConvictionDate.Text).Clip()
            cmdSave.Parameters("state").Value = ddlConvictionState.SelectedValue
            cmdSave.Parameters("charge").Value = txtConvictionCharge.Text
            cmdSave.Parameters("penalty").Value = txtConvictionPenalty.Text

            hidId.Value = cmdSave.ExecuteScalar()
        Next

    End Sub

    Private Sub _SaveDocument(connection As SqlConnection, transaction As SqlTransaction)
        Dim ReportDataSet As New dsAppDrivingExperience
        Dim ReportTableAdapter As New TransactionalAppDrivingExperienceTableAdapter
        ReportTableAdapter.SetConnection(connection, transaction)
        ReportTableAdapter.Fill(ReportDataSet.AppDrivingExperienceDataTable, Master.app.id)

        Using Report As New crptAppDrivingExperience
            Report.SetDataSource(ReportDataSet)
            Dim rawData = Reporting.StreamToByteArray(Report)

            Dim cmdSave = "
                UPDATE web_DriverApplicationPdf SET pageTitle=@pageTitle, pdfData=@pdfData, pdfDataSize=@pdfDataSize
                WHERE appId=@appId AND pageFileName=@pageFileName;
                IF @@ROWCOUNT = 0 BEGIN
                    INSERT INTO web_DriverApplicationPdf (appId, pageTitle, pageFileName, pdfData, pdfDataSize)
                    VALUES (@appId, @pageTitle, @pageFileName, @pdfData, @pdfDataSize);
                END"
            Dim cmd As New SqlCommand(cmdSave, connection, transaction)
            cmd.Parameters.AddWithValue("appId", Master.app.id)
            cmd.Parameters.AddWithValue("pageTitle", Master.CurrentTitle)
            cmd.Parameters.AddWithValue("pageFileName", Master.CurrentPage)
            cmd.Parameters.AddWithValue("pdfData", rawData)
            cmd.Parameters.AddWithValue("pdfDataSize", rawData.Length)
            cmd.ExecuteNonQuery()
        End Using
    End Sub

#End Region

#Region "Other internals"


    Private Function _HasEnteredLastViolation() As Boolean
        Dim count = rptViolations.Items.Count
        If count = 0 Then
            Return True
        Else
            Dim item As RepeaterItem = rptViolations.Items(count - 1)
            Dim txtConvictionDate As TextBox = item.FindControl("txtConvictionDate")
            Return txtConvictionDate.Text.Length > 0
        End If
    End Function

    Private Function _HasVisited() As Boolean
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()
            Dim cmd As New SqlCommand(
                "SELECT hasHadConvictions FROM web_DriverApplication WHERE id=@appId",
                connection)
            cmd.Parameters.AddWithValue("appId", Master.app.id)
            Return TypeOf cmd.ExecuteScalar() IsNot DBNull
        End Using
    End Function


    Private Sub _RemoveViolation(itemId As Integer)
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()
            Dim cmd As New SqlCommand(
                "DELETE FROM web_DriverApplicationConvictions WHERE id=@itemId",
                connection)
            cmd.Parameters.AddWithValue("itemId", itemId)
            cmd.ExecuteNonQuery()
        End Using
    End Sub

#End Region

End Class